# go-server-with-otel

Template for a go HTTP + GRPC server with OTEL support. Uses the go-app
framework to easily bootstrap a new app with all the bells and whistles.

The provided proto returns a random fact, and serves only as a reference.
It has support for grpc-gateway, and produces an openapi2/swagger spec for
use with postman, etc..

## Getting Started

1. Rename your package using `make rename NAME=my.gitremote.com/pathto/repo`
1. Review the config struct, adding any app-specific configuration
   1. This will be merged with the go-app config, giving logging/http/grpc
      configuration for free
1. Generate a new json schema, for use with your config.yaml: `make schema`
   1. Ensure you have yaml+json tags
   1. The yaml-language-server lsp plugin for your favorite editor should
      pull in the schema using the comment in `config.yaml`
1. Run `make proto` after updating proto changes, and add any
   1. paths under proto/ as necessary
1. Implement your things
1. Update parameters in `.gitea/workflows/ci.yaml` for your app
